#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <map>
#include <vector>
#include <set>

using namespace std;

typedef struct
{
        int node;
        float vzdalenost; // tato struktura je v mnozine sousedu urciteho uzlu u; vzdalenost od u k uzlu node
} info_sousedi;


// tato trida je nutna kvuli porovnavani pro ukladani do mnoziny
class mnoz_less
{
  public:
    bool operator()(info_sousedi m1, info_sousedi m2) const
    {
      return m1.node < m2.node;
    }
};

typedef struct  /* struktura obsahujici sumu stejnych cisel FNODE a TNODE a mnozinu sousedu uzlui*/
{
    int suma_nodu;// kolikrat se v souboru nachazi uzel NODE
    set<info_sousedi,mnoz_less> sousedi; // sousedi uzlu spolu se vzdalenosti
}Info_NODE;



int main()
{

    char nazev_souboru[50];


    cout << "Zadej nazev souboru obsahujici poxty uzlu." << endl;     // soubor FNODU a TNODU, ktery chci nacist
    cout <<" Jmenuje se spojeniNODU.txt "<< endl;
    cin >>nazev_souboru;


    ifstream vstupniNODE;
    vstupniNODE.open(nazev_souboru);


    int i;
    i = 0;
    while((vstupniNODE.is_open()!=true) && i<10)        //testuji, zda je soubor spravne otevren,zepta se me 10 x a pote program ukonci
    {
        cout << "Chyba pri nacitani ze vstupniho souboru! Zadej spravne nazev souboru k nacteni"<< endl;
        cin >>nazev_souboru;
        i++;
        vstupniNODE.open(nazev_souboru);
    }
    if (vstupniNODE.is_open()==false)       //soubor se neotevrel, ukonci program
    return 1;

    int suma;
    int node;
    string radek;
    getline(vstupniNODE,radek);     //nacteny prvni radek zahodim, jsou to nazvy sloupcu
    getline(vstupniNODE,radek);     //nactu druhy

    // radek souboru ma podobu
    // 2	23785
    // coz znamena, ze uzel 23785 ma stupen 2


    istringstream radek_k_zpracovani;   //zde chci radek rozparcelovat
    Info_NODE info;
    map <int,Info_NODE> graf;

    i=0;
    while(vstupniNODE.eof()!=true)
    {
        // prectu radek ze souboru
        radek_k_zpracovani.str(radek);
        radek_k_zpracovani.clear();
        // ulozim stupen a cislo uzlu
        radek_k_zpracovani >> suma >> node;
        // pokud se spravne nacetlo
        if(radek_k_zpracovani.fail()==false)
        {
           //cout<< suma<<"  " <<node<<endl;   //kontrola vypisem
           info.suma_nodu = suma;
           graf[node]= info;
           // cout << node <<" "<< info.suma_nodu <<endl; //kontrola vypisem


        }

        else
                cout << "Chyba pri cteni z radku!  " << endl;

       getline(vstupniNODE,radek);

    }




        /*for (i=0;i<100;i++)
        {
            cout << " na "<< i << ".    pozici je NODE cislo: "<< poleNODU[i]<< endl;
        }
        cout << "pocet vsech nactenych NODU je: " << poleNODU.size() << endl; */



        cout << "Zadej nazev souboru, ktery obsahuje delku jednotlivych useku (FNODE - TNODE)" << endl;     //nacitani souboru, ve kterem jsou vzdalenosti
        cout << " Zadej length.txt"<< endl;
        cin >> nazev_souboru;
        ifstream vstupniLENGTH;
        vstupniLENGTH.open(nazev_souboru);

        if (vstupniLENGTH.is_open()==false)
        {
            cout<< "Spatny nazev souboru, ukoncuji program! " << endl;  //soubor se neotevrel, ukonci program
            return 1;
        }

        int node1,node2;
        float vzdalenost;
        getline(vstupniLENGTH,radek); // prvni radek zahazuju
        getline(vstupniLENGTH,radek);


        info_sousedi vkladany_soused;
        pair<set<info_sousedi>::iterator,bool> ret;

        while(vstupniLENGTH.eof()!=true)
        {
            radek_k_zpracovani.str(radek);
            radek_k_zpracovani.clear();
            radek_k_zpracovani >> node1 >> node2>> vzdalenost;
            if(radek_k_zpracovani.fail()==false)
            {

                vkladany_soused.node=node2;     //vlozeni k nodu 1 jeho souseda node2 (FNODE -TNODE)
                vkladany_soused.vzdalenost=vzdalenost;
                ret=graf[node1].sousedi.insert(vkladany_soused);
                if(ret.second==false)
                {
                    cerr << "Chyba v datech: soused "<< node2 << " k uzlu " << node1 << " uz byl vlozen" << endl;
                }

                vkladany_soused.node=node1;     //vlozeni k nodu 2 jeho souseda node1 -symetricky (FNODE -TNODE)
                ret=graf[node2].sousedi.insert(vkladany_soused);
                if(ret.second==false)
                {
                    cerr << "Chyba v datech: soused "<< node1 << " k uzlu " << node2 << " uz byl vlozen" << endl;
                }

           //cout<< suma<<"  " <<node<<endl;

           //cout << node1 <<" "<<node2<<"  "<< vzdalenost <<endl;

            }

        else

            {
                cout << "Chyba pri cteni z radku!  " << endl;

            }
            getline(vstupniLENGTH,radek);
        }





    vstupniNODE.close();
    vstupniLENGTH.close();
    ofstream vystup;
    vystup.open("vystup_redukovany_graf.txt");





     // mapa dvojic  [uzel,stupen uzlu]
     // vkladam tam pouze ty, ktere maji stupen uzlu 3 a vice
     map<int,int> mnozina;

     map<int,Info_NODE>::iterator prohledavac; // iterator, ktery mi prochazi mapu od zacatku do konce

    for(prohledavac=graf.begin();prohledavac!=graf.end();prohledavac++)
    if ((*prohledavac).second.suma_nodu>=3) // node ulozim do mnoziny, pokud je tam vice nez 3 x
    {
        mnozina[(*prohledavac).first]=(*prohledavac).second.suma_nodu;
    }

    map<int,int>::iterator zpracovavany;
   /* for(zpracovavany=mnozina.begin();zpracovavany!=mnozina.end();zpracovavany++)
    cout << (*zpracovavany).first << " " << (*zpracovavany).second << endl; */


    int soused;
    set<info_sousedi,mnoz_less>::iterator it_soused;
    float celkova_meziuzlova_vzdal; // scitam vzdalenosti mezi krizovatkami
    int zpracovavany_node;       //zpracovavany node pro porovnavani - hledam ten stejny v matici
    int predchozi_node;
    info_sousedi mazany_soused;

    while ( mnozina.empty()==false)
    {
        zpracovavany=mnozina.begin(); //vyzvednu si iterator na prvni node

        zpracovavany_node =(*zpracovavany).first;   // priradim do zpracovavany_node cislo nodu, ktery potrebuju pro hledani
        while((*zpracovavany).second>0)
        {


            it_soused=graf[zpracovavany_node].sousedi.begin();//vyzvednusi iterator na prvniho souseda
            if (it_soused == graf[zpracovavany_node].sousedi.end())
            {
                cerr << "Fronta sousedu uzlu " << zpracovavany_node << " je prazdna." << endl;
                (*zpracovavany).second=0;
                break;
            }
            celkova_meziuzlova_vzdal=(*it_soused).vzdalenost; // vyzvednu vzdalenost
            soused=(*it_soused).node; //vyzvednu cislo nodu nasledujiciho souseda
            graf[zpracovavany_node].sousedi.erase(it_soused); // vymazu ho z mnoziny sousedu
            mazany_soused.node=zpracovavany_node;

            if (graf[soused].sousedi.erase(mazany_soused)==0)// vymazu ho z mnoziny sousedu
            cerr <<"Chyba pri mazani! uzel ke smazani "<<zpracovavany_node<<" se nenachazi v mnozine sousedu, nelze ho smazat"<< endl;

            while(graf[soused].suma_nodu==2)
            {
              predchozi_node = soused;
              it_soused=graf[predchozi_node].sousedi.begin();
              celkova_meziuzlova_vzdal=celkova_meziuzlova_vzdal+(*it_soused).vzdalenost;
              soused=(*it_soused).node;
              graf[predchozi_node].sousedi.erase(it_soused);
              mazany_soused.node=predchozi_node;
              if (graf[soused].sousedi.erase(mazany_soused)==0)// vymazu ho z mnoziny sousedu
                 cerr<<"Chyba pri mazani! uzel ke smazani "<<zpracovavany_node<<" se nenachazi v mnozine sousedu, nelze ho smazat"<< endl;

            } // end while

                cout << zpracovavany_node<<"\t"<<soused<<"\t"<<celkova_meziuzlova_vzdal<<endl;
                vystup <<zpracovavany_node<<"\t"<<soused<<"\t"<<celkova_meziuzlova_vzdal<<endl;
                // koncovy je v mnozine jeno tehdy, kdyz ma stupen >=3
                if(graf[soused].suma_nodu>=3)
                  mnozina[soused]--;




             // snizim stupen uzlu
            (*zpracovavany).second--;
        } // end while
        mnozina.erase(zpracovavany); // smazu zpracovany uzel, prosel jsem vsechny cesty od nej

    } //end while





    vystup.close();


    return 0;
}
